/* compile.c
	P.Chongstitvatana
	19 Aug 97
	1 Sept 97
	3 Apr 2001  	start project RZ
	1 Jan 2002  	generate s2 code
	27 Sept 2010   	begin project rz3, generate parse-tree
	8 Jan 2013		gen code for s2.3
	19 Feb 2013     gen code for s2.3x  dual core
*/

#include "compile.h"

extern int pass(void);		// parse.c
extern int nsym;			// number of symbol in symbol table
FILE *FO;					// output file

void strcat2(char *s1, char *s2, char *s3){
	strcpy(s1,s2);
	strcat(s1,s3);
}
/*
// search symbol table for Function and show it
void showParseTree(void){
	int i;
	for(i=1; i<=nsym; i++)
		if(getType(i) == tyFUNCTION || getType(i) == tyMACRO){
			printList(getRef(i));
			printf("\n");
		}
}
*/
void showGlobal(void){
	int i, ty;
	for(i=1; i<=nsym; i++){
		ty = getType(i);
		if(ty == tySCALAR || ty == tyVECTOR){
			printf("%s type %d ref %d\n",getName(i),ty,getRef(i));
		}
	}
}

// search symbol table for FUNCTION and generate its code
void genall(void){
	int i;
	for(i=1; i<=nsym; i++)
		if(getType(i) == tyFUNCTION){
			genex(getRef(i));
		}
}

void epilog(void){
	printf(".data %d\n.end\n",DSBASE);
}

void outHeader(void){
	int i, ty;
	printf(".symbol\n fp 30\n sp 29\n retval 28\n rads 27\n");
	for(i = 1; i <= nsym; i++){
		ty = getType(i);
		if(ty == tySCALAR || ty == tyVECTOR){
			printf(" %s %d\n",getName(i),getRef(i));
		}
	}
	printf(".code 100\n mov fp #10500\n mov sp #10000\n");
	printf(" mov r1 #_core2\n st r1 20\n");
	printf(" jal rads main\n trap r0 #0\n");
	printf(":_core2\n jal rads main2\n trap r0 #0\n");
}

void testlex(void){
	while(tok != tkEOF){
		prtoken(tok);
		printf(" '%d ",tok);
		mylex();
	}
}

int main( int argc, char *argv[] ){
	string source, code, list, iasm, name;
	char *fname;
	int f;

	if( argc < 2 ) {
		printf("usage : compile source\n");
		exit(-1);
	}
	strcpy(source,argv[1]);
	strcpy(name,source);
	fname = strtok(name,".");
	if( fname == NULL ) fname = name;
	strcat2(code,fname,".obj");
//	strcat2(list,fname,".lst");
//	strcat2(iasm,fname,".s2");

	readinfile(source);
//	testlex();
//	dumpSymTab();
//	exit(0);

	f = pass();
	if( f )
		printf("yes\n");
//	showParseTree();
//	showGlobal();
//	exit(0);

//	outHeader();
//	genall();
	dumpSymTab();
//	epilog();
	return 0;
}

//  -----  test ------

/*
void testlex(void){
	mylex();
	while( tok != tkEOF ){
		printf(" ");
		prtoken(tok);
		mylex();
	}
}
*/

/*
void testgets(char *fn){
	FILE *fp;
	char buf[100];
	int line = 0;
	fp = fopen(fn,"rt");
	while( fgets(buf,100,fp) != NULL){
		line++;
		printf("%d: %s",line,buf);
	}
	fclose(fp);
}

PRIVATE char buf[1000];
PRIVATE FILE *fp;
PRIVATE int mline, mcol;
char *mcp;

void mygetC(void){
	char *c;
	if( *mcp == 0 ){
		c = fgets(buf,1000,fp);
		mcp = buf;
		mcol = 0;
		mline++;
		if( c == NULL ) *mcp = EOF_CHAR;
	}
	if( CH != EOF_CHAR ){
		CH = *mcp++;
		mcol++;
	}
}

void testgetfile(char *fn){
	int k = 0;
	mcp = buf;
	fp = fopen(fn,"rt");
	*mcp = 0;
	mygetC();
	while( CH != EOF_CHAR ){
		myskip();
		printf("%c",CH);
		mygetC();
		k++;
		if(k > 2000) exit(0);
	}
	fclose(fp);
}
*/
// move c-string from strbuf to M[] at STRBASE
/*
extern char strbuf[];
extern int freestr;
int M[MAXMEM];

void dumpString(void){
	int i;
	for(i=0; i<freestr; i++)
		M[STRBASE+i] = (int)(unsigned char)strbuf[i];
}
// produce object code
void outObj(string fn){
	FO = fopen(fn,"wt");
	fprintf(FO,"%d\n",SOM_V2_MAGIC);
//	outM(CS,1,CP-1);
	dumpString();
//	outM(M,STRBASE,STRBASE+freestr-1);
	dumpSymTab();
	fclose(FO);
}
*/

